QCPLineEnding Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions
QCPLineEnding Class Reference

Handles the different ending decorations for line-like items. More...

## Public Types
enum | EndingStyle

## Public Functions
| QCPLineEnding ()
| QCPLineEnding (EndingStyle style, double width=8, double length=10, bool inverted=false)
EndingStyle | style () const
double | width () const
double | length () const
bool | inverted () const
void | setStyle (EndingStyle style)
void | setWidth (double width)
void | setLength (double length)
void | setInverted (bool inverted)
double | boundingDistance () const
double | realLength () const
void | draw (QCPPainter *painter, const QCPVector2D &pos, const QCPVector2D &dir) const
void | draw (QCPPainter *painter, const QCPVector2D &pos, double angle) const

## Detailed Description

Handles the different ending decorations for line-like items.

The various ending styles currently supported

For every ending a line-like item has, an instance of this class exists. For example, QCPItemLine has two endings which can be set with QCPItemLine::setHead and QCPItemLine::setTail.

The styles themselves are defined via the enum QCPLineEnding::EndingStyle. Most decorations can be modified regarding width and length, see setWidth and setLength. The direction of the ending decoration (e.g. direction an arrow is pointing) is controlled by the line-like item. For example, when both endings of a QCPItemLine are set to be arrows, they will point to opposite directions, e.g. "outward". This can be changed by setInverted, which would make the respective arrow point inward.

Note that due to the overloaded QCPLineEnding constructor, you may directly specify a QCPLineEnding::EndingStyle where actually a QCPLineEnding is expected, e.g.

myItemLine->setHead(QCPLineEnding::esSpikeArrow);

## Member Enumeration Documentation

## § EndingStyle

enum QCPLineEnding::EndingStyle

Defines the type of ending decoration for line-like items, e.g. an arrow.

The width and length of these decorations can be controlled with the functions setWidth and setLength. Some decorations like esDisc, esSquare, esDiamond and esBar only support a width, the length property is ignored.

See also
  QCPItemLine::setHead, QCPItemLine::setTail, QCPItemCurve::setHead, QCPItemCurve::setTail, QCPAxis::setLowerEnding, QCPAxis::setUpperEnding

Enumerator
esNone | No ending decoration.
esFlatArrow | A filled arrow head with a straight/flat back (a triangle)
esSpikeArrow | A filled arrow head with an indented back.
esLineArrow | A non-filled arrow head with open back.
esDisc | A filled circle.
esSquare | A filled square.
esDiamond | A filled diamond (45 degrees rotated square)
esBar | A bar perpendicular to the line.
esHalfBar | A bar perpendicular to the line, pointing out to only one side (to which side can be changed with setInverted)
esSkewedBar | A bar that is skewed (skew controllable via setLength)

## Constructor & Destructor Documentation

## § QCPLineEnding() [1/2]

QCPLineEnding::QCPLineEnding | ( |  | ) |

Creates a QCPLineEnding instance with default values (style esNone).

## § QCPLineEnding() [2/2]

QCPLineEnding::QCPLineEnding | ( | QCPLineEnding::EndingStyle | style,
|  | double | width = `8`,
|  | double | length = `10`,
|  | bool | inverted = `false`
| ) |  |

Creates a QCPLineEnding instance with the specified values.

## Member Function Documentation

## § setStyle()

void QCPLineEnding::setStyle | ( | QCPLineEnding::EndingStyle | style | ) |

Sets the style of the ending decoration.

## § setWidth()

void QCPLineEnding::setWidth | ( | double | width | ) |

Sets the width of the ending decoration, if the style supports it. On arrows, for example, the width defines the size perpendicular to the arrow's pointing direction.

See also
  setLength

## § setLength()

void QCPLineEnding::setLength | ( | double | length | ) |

Sets the length of the ending decoration, if the style supports it. On arrows, for example, the length defines the size in pointing direction.

See also
  setWidth

## § setInverted()

void QCPLineEnding::setInverted | ( | bool | inverted | ) |

Sets whether the ending decoration shall be inverted. For example, an arrow decoration will point inward when inverted is set to true.

Note that also the width direction is inverted. For symmetrical ending styles like arrows or discs, this doesn't make a difference. However, asymmetric styles like esHalfBar are affected by it, which can be used to control to which side the half bar points to.

## § boundingDistance()

double QCPLineEnding::boundingDistance | ( |  | ) | const

Returns the maximum pixel radius the ending decoration might cover, starting from the position the decoration is drawn at (typically a line ending/QCPItemPosition of an item).

This is relevant for clipping. Only omit painting of the decoration when the position where the decoration is supposed to be drawn is farther away from the clipping rect than the returned distance.

## § realLength()

double QCPLineEnding::realLength | ( |  | ) | const

Starting from the origin of this line ending (which is style specific), returns the length covered by the line ending symbol, in backward direction.

For example, the esSpikeArrow has a shorter real length than a esFlatArrow, even if both have the same setLength value, because the spike arrow has an inward curved back, which reduces the length along its center axis (the drawing origin for arrows is at the tip).

This function is used for precise, style specific placement of line endings, for example in QCPAxes.

## § draw() [1/2]

void QCPLineEnding::draw | ( | QCPPainter * | painter,
|  | const QCPVector2D & | pos,
|  | const QCPVector2D & | dir
| ) |  | const

Draws the line ending with the specified painter at the position pos. The direction of the line ending is controlled with dir.

## § draw() [2/2]

void QCPLineEnding::draw | ( | QCPPainter * | painter,
|  | const QCPVector2D & | pos,
|  | double | angle
| ) |  | const

This is an overloaded function.

Draws the line ending. The direction is controlled with the angle parameter in radians.

The documentation for this class was generated from the following files:

- src/lineending.h
- src/lineending.cpp